#include <Adafruit_NeoPixel.h>

#define PIN 6

Adafruit_NeoPixel strip = Adafruit_NeoPixel(16, PIN, NEO_GRB + NEO_KHZ800);

// These constants won't change.  They're used to give names
// to the pins used:
const int analogInPinR = A0;  // Analog input pin that the potentiometer is attached to
const int analogInPinG = A1;
const int analogInPinB = A2;


int sensorValueR = 0;        // value read from the pot
int sensorValueG = 0;
int sensorValueB = 0;
int R = 0;        
int G = 0;
int B = 0;
uint32_t a;

void setup() {
  strip.begin();
  strip.show(); // Initialize all pixels to 'off'
  measure();
  a = strip.Color(R, G, B);
}

void loop() {
   rainbowCycle(20);
}


// Slightly different, this makes the rainbow equally distributed throughout
void rainbowCycle(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256; j++) { // 5 cycles of all colors on wheel
    for(i=0; i< strip.numPixels(); i++) {
      if(a==0)
        strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
      else
        strip.setPixelColor(i,a);
    }
    strip.show();
    delay(wait);
    measure();
    a = strip.Color(R, G, B); 
  }
}



// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  if(WheelPos < 85) {
   return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  } else if(WheelPos < 170) {
   WheelPos -= 85;
   return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  } else {
   WheelPos -= 170;
   return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
}

void measure(void) {
 // read the analog in value:
  sensorValueR = analogRead(analogInPinR);
  sensorValueG = analogRead(analogInPinG);
  sensorValueB = analogRead(analogInPinB);
  // map it to the range of the analog out:
  R = map(sensorValueR, 0, 1023, 0, 255);
  G = map(sensorValueG, 0, 1023, 0, 255);
  B = map(sensorValueB, 0, 1023, 0, 255);  
}
